% create graph like benhabib schmitt grohe uribe

clear all 
close all

% linearized, no price stickiness. 

phi = 2; 
r = 0.02; 
inf_star = 0.02; % inflation target

inft = (-0.05:0.002:0.05)'; % pi_t$
inft1a =  phi*(inft-inf_star) + inf_star;
inft1b = -r+(0*inft);
inft1 = (max([inft1a';inft1b']))';

inftsim = 0.0125; % starting point. 

for indx = 2:10; 
    inftsim(indx) = max(phi*(inftsim(indx-1)-inf_star)+inf_star,-r); 
end; 
inftsim = inftsim';
inftsim_plot = kron(inftsim,[1;1]); 

figure
plot((inft)*100,(inft1a)*100,'--k','linewidth',2);
hold on
plot((inft)*100,(inft1)*100,'-b','linewidth',3);
plot((inft)*100,(inft)*100,'-k','linewidth',2);
plot(2,2,'bo','markersize',10,'markerfacecolor','b')
plot(-2,-2,'ro','markersize',10,'markerfacecolor','r')
%plot(100*inftsim_plot(1:end-1),100*inftsim_plot(2:end),'-v'); 
quiver(100*inftsim_plot(1:end-2),100*inftsim_plot(2:end-1),...
100*inftsim_plot(2:end-1)-100*inftsim_plot(1:end-2),...
100*inftsim_plot(3:end)-100*inftsim_plot(2:end-1),0,'color','r',...
'linewidth',2);
text(-1.5,-2.7,'\pi_{t+1} = max[\phi(\pi_t-\pi^\ast)+r, -r]',...
    'color','b','backgroundcolor', 'w','fontsize',20);

axis([-3 3 -3.5 3.5]);
%print -depsc2 bsgu_plot.eps

% version with price stickiness -- currently only one used in paper. 

phi = 2; 
r = 0.02; 
inf_star = 0.02; % inflation target
ks = 2; % kappa sigma

inft = (-0.05:0.002:0.05)'; % pi_t$
inft1a =  (1+ks*phi)/(1+ks)*(inft-inf_star) + inf_star;
inft1b = 1/(1+ks)*inft-ks/(1+ks)*r+(0*inft);
inft1 = (max([inft1a';inft1b']))';

inftsim = 0.01; % starting point. 

for indx = 2:10; 
    if inf_star + r + phi*(inftsim(indx-1) - inf_star) > 0; 
        inftsim(indx) = (1+ks*phi)/(1+ks)*(inftsim(indx-1)-inf_star) + inf_star;
    else; 
        inftsim(indx) = 1/(1+ks)*inftsim(indx-1)-ks/(1+ks)*r;
    end;
end; 
inftsim = inftsim';
inftsim_plot = kron(inftsim,[1;1]); 

figure
plot((inft)*100,(inft1a)*100,'--k','linewidth',2);
hold on
plot((inft)*100,(inft1)*100,'-b','linewidth',3);
plot((inft)*100,(inft)*100,'-k','linewidth',2);
plot(2,2,'bo','markersize',10,'markerfacecolor','b')
plot(-2,-2,'ro','markersize',10,'markerfacecolor','r')
%plot(100*inftsim_plot(1:end-1),100*inftsim_plot(2:end),'-v'); 
quiver(100*inftsim_plot(1:end-2),100*inftsim_plot(2:end-1),...
100*inftsim_plot(2:end-1)-100*inftsim_plot(1:end-2),...
100*inftsim_plot(3:end)-100*inftsim_plot(2:end-1),0,'color','r',...
'linewidth',2);
%text(-1.5,-2.7,'\pi_{t+1} = max[\phi(\pi_t-\pi^\ast)+r, -r]',...
 %   'color','b','backgroundcolor', 'w','fontsize',20);

axis([-3 3 -3 3]);
xlabel('\pi_t','fontsize',20);
ylabel('E_t \pi_{t+1}', 'fontsize',20);
print -depsc2 bsgu_plot_sticky.eps




stop

% full nonlinear version 

phi = 2; 
r = 0.02; 
inf_star = 1.02; % inflation target

inft = (0.95:0.002:1.1)'; % 1+pi_t$
inft1a = (inft/inf_star).^phi/(1+r)*inf_star*(1+r);
inft1b = 1/(1+r)+(0*inft);
inft1 = (max([inft1a';inft1b']))';

figure
plot((inft-1)*100,(inft1a-1)*100,'--','linewidth',2);
hold on
plot((inft-1)*100,(inft1-1)*100,'-r','linewidth',3);
plot((inft-1)*100,(inft-1)*100,'-k','linewidth',2);
plot(2,2,'bo','markersize',7,'markerfacecolor','b')
plot(-2,-2,'ro','markersize',7,'markerfacecolor','r')



axis([-3 3 -inf inf]);
