
function [bigpit, bigxt, dsbig] = fn_add_delta(tim,Tb,l1,l2,d0,pit,xt,b,s,k,t0,Vterm,use_r);
% adds delta to basic pi and x solutions, computes fiscal surplus
%Vterm = 0 signals use the linearized one period debt calcualtion
% Vterm = 1 lets you use full nonlinear discounting with one period debt 
% 0 and 1 produce nearly identical results -- linearization is not a big
% deal here. 
%Otherwise Vterm = value of debt after shock / value before shock. 
%use_r option 0 allows you to turn off the interest rate effect on
%surpluses

%T = (size(tim,1)-1)/2; for symmetric tim only
%dt = ([zeros(T-Tb,1); (1/l1).^(-Tb:T)'])*d0; size(dt)% a delta series 

T = (size(tim,1)-t0); % number after t0
dt = ([zeros(t0-Tb-1,1); (1/l1).^(-Tb:T)'])*d0; % a delta series ; initial shock d0 decays

% Tb is how many periods before 0 the announcement is made
% d0 is how much to shift inflation at time 0
% search function only asks for scalar d0

if size(d0,1) > 1 ; 
    disp('fn_add_delta: d0 must be row vector');
end;

bigpit = pit*ones(size(d0))+dt; 
bigpit(1:t0-Tb-1,:) = NaN*bigpit(1:t0-Tb-1,:);

bigxt = [bigpit(1:end-1,:) - b*bigpit(2:end,:); NaN(1,size(bigpit,2))]/k;
bigxt(1:t0-Tb-1,:) = NaN*bigxt(1:t0-Tb-1,:);

test=0;
    if Vterm == 0;
        dsbig = -bigpit(t0-Tb,:)  ...
            + 1/sum( b.^(0:T-1+Tb)')...% ut off sum. produces same result as next. use +(1-b) and fill out limits? x does not go to zero...
            *use_r*1/s*sum( ((b.^(0:T-1+Tb)')*ones(size(d0))) .*...
            (bigxt(t0-Tb:end-1,:) - ones(size(bigxt(t0-Tb:end-1,:),1),1)*bigxt(t0-Tb,:)) );
    end;
    if ~(Vterm == 0);
        dsbig = -bigpit(t0-Tb,:)/100 + log(Vterm)...
            + use_r*log( sum( b.^(0:T-1+Tb)')) ... % truncate sum here to match
            - use_r*log( sum( ((b.^(0:T-1+Tb)')*ones(size(d0))) .*...
            exp( (-1/s)*(bigxt(t0-Tb:end-1,:) - ones(size(bigxt(t0-Tb:end-1,:),1),1)*bigxt(t0-Tb,:))/100 )));
        dsbig = 100*dsbig;
    end;

        

