% function fn_find_ir_lagpi. Finds impulse response functions with lags in the PHillips curve. 
% OBSOLETE incorporated into fn_find_ir
%clear all
%close all
 
% parameters
%b = 0.97; % beta
%k = 0.2; % kappa
%s = 0.3; % sigma
%xi = 0.1; % xi interest elasticity of money demand
%mc = 0; % money to output ratio
%rho = 0.96; % coefficient on lagged inflation in phillips

%itargt = [zeros(10,1);1;ones(30,1)]; %interest target
%itargt = [zeros(10,1);1;0.6.^(1:10)']; %interest target

%tim = (-10:30)';
%t0 = 11; % index of t = 0

                                                             

function [pit,xt,pit_unex,xt_unex,r1,r2,l3,phi,ma] = fn_find_ir_lagpi(itargt,t0,b,k,s,xi,mc,rho,mamax);

% itargt is a vector consisting of the interest rate target path. 
if rho > b; 
    disp('find_ir_lagpi: rho cannot exceed b. rho and b are ')
    disp([rho b])
end;

if rho < b;
    phi = (b-rho)./(1+b*rho-2*rho);
    
    p = [ 1 -(1+phi+k*s+ phi*rho*(1-k*s))/phi (1+rho*(1+phi))/phi -rho/phi];
    r = roots(p);
    r12 = r(r<1);
    r1 = min(r12);
    r2 = max(r12);
    r3 = r(r>1); % uses r = 1/lambda to handle rho = 0, r=0, lambda = infty
    l3 = 1/r3;
end; 
if rho == b
     phi = 0;
     r1 = ((1+b)-sqrt((1-b)^2-4*b*k*s))/(2*(1+k*s));
     r2 = ((1+b)+sqrt((1-b)^2-4*b*k*s))/(2*(1+k*s));
     l3 = 0; 
end;

% for comparison when debugging 
%l1o = ((1+b+k*s)+ ((1+b+k*s)^2-4*b)^0.5)/2;
%l2o = ((1+b+k*s)- ((1+b+k*s)^2-4*b)^0.5)/2;

T = size(itargt,1); 

% two sided MA for inflation, then output 
%mamax = 200; % size of two sided moving average. Make it big. 

itargt = [ones(mamax,1)*itargt(1) ; itargt; ones(mamax,1)*itargt(end)]; % pad target for ma
zt = itargt - (s-xi)*mc*([itargt(2:end)-itargt(1:end-1); 0]);
zt_unex = zt;
zt_unex(t0+mamax-1) = itargt(t0+mamax-1) + 0; % they don't know 0 ahead of time


% moving average for inflation in equilibrium
if rho < b
    ma = zeros(2*mamax+1,1);
    ma(1:mamax) = l3.^(mamax:-1:1)'; % forward. filter wants a one-sided ma
    ma(mamax+1) = 1;
    ma(mamax+2:end) = (r1*(1-r2*l3)/(r1-r2))*(r1).^((1:1:mamax)')...
        -(r2*(1-r1*l3)/(r1-r2))*(r2).^((1:1:mamax)');
    ma = k*s*(1-phi*rho)/phi * l3/((1-l3*r1)*(1-l3*r2))*ma;
end;
if rho == b;
    ma = zeros(2*mamax+1,1);
    %ma(1:mamax) = l3.^(mamax:-1:1)'; % forward. filter wants a one-sided ma
    ma(mamax+1) = 1;
    ma(mamax+2:end) = r1/(r1-r2)*r1.^((1:1:mamax)') - r2/(r1-r2)*r2.^((1:1:mamax)');
    ma = k*s/(1+k*s)*ma;
end;
% find inflation, output, by applying two sided filer
if abs(sum(ma)-1)>0.01; 
    disp('fn_find_ir_lagpi: sum of ma is not one. likely increase maxma')
    disp('sum(ma), rho, phi')
    disp([sum(ma) rho phi]); 
end; 
pit = filter(ma,1,zt);
pit_unex = filter(ma,1,zt_unex);

if 0; % need to derive and program direct solution -- this is the old one. but indirect works fine. 
    ma_x = zeros(2*mamax+1,1);
    ma_x(1:mamax) = (1-b/l2)*l2.^(mamax:-1:1)'; % forward. filter wants a one-sided ma
    ma_x(mamax+1) = 1-b/l1;
    ma_x(mamax+2:end)=(1-b/l1)*(1/l1).^(1:1:mamax)';
    ma_x = k*s/(l1-l2)*ma_x;

    xt = filter(ma_x,1,zt)/k;
    pit_unex = filter(ma,1,zt_unex);
    xt_unex = filter(ma_x,1,zt_unex)/k;
else; % This does not include zt effect -- need to think that one through if you use it. 
    xt = ((1+phi*rho)/(1-phi*rho)*pit(2:end-1) - phi/(1-phi*rho)*pit(3:end) - rho/(1-phi*rho)*pit(1:end-2))/k; 
    xt_unex = xt; 
    xt = [NaN; xt; NaN]; 
    xt_unex = [NaN; xt_unex; NaN]; 
end

% shift pi, x to be two sided filter
pit = [pit(mamax:end);NaN(mamax-1,1)]; % pi t+1 lines up with it
xt = [xt(mamax:end);NaN(mamax-1,1)]; 
pit_unex = [pit_unex(mamax:end);NaN(mamax-1,1)]; % pi t+1 lines up with it
xt_unex = [xt_unex(mamax:end);NaN(mamax-1,1)]; 

% get rid of early and late observations past ma length

itargt = itargt(mamax+1:end-mamax); % should be the same as before padding
pit = pit(mamax+1:end-mamax); 
xt = xt(mamax+1:end-mamax); 
pit_unex = pit_unex(mamax+1:end-mamax); 
xt_unex = xt_unex(mamax+1:end-mamax); 

% set to zero variables before the announcement date.

pit_unex(1:t0-1) = 0;
xt_unex(1:t0-1) = 0;

%%%%%%%%%%%%

if 0;
    figure
    plot(tim,itargt,'-v','linewidth',2);
    hold on
    plot(tim,pit_unex,'-rs','linewidth',2);
    plot(tim,xt_unex,'-ko','linewidth',2);
    
    plot(tim,pit,'--rs','linewidth',2);
    plot(tim,xt,'--ko','linewidth',2);
    plot(tim,0*tim,'-k')
    axis([-5 inf -inf inf]);
    legend('i','\pi','x','location','NorthWest');
    xlabel('Time');
    ylabel('Percent response')
end;

