% inflation_graphs
% this is edited for final version of MM Fisher Occam
% the version in root directory has lots more


clear all
close all

firstdate = 1995; 
j_firstdate = 1990; 

x = load('TB3MS.TXT'); 
tb3_date = x(:,1:3);
tb3 = x(:,4); 
indx = find((tb3_date(:,1)==firstdate)&(tb3_date(:,2)==01));
tb3_date = tb3_date(indx:end,:);
tb3 = tb3(indx:end); 
tb3_tim = datenum(tb3_date); 

x = load('fedfunds.TXT'); 
ff_date = x(:,1:3);
ff = x(:,4); 
indx = find((ff_date(:,1)==firstdate)&(ff_date(:,2)==01));
ff_date = ff_date(indx:end,:);
ff = ff(indx:end); 
ff_tim = datenum(ff_date); 

x = load('GS10.TXT'); 
G10_date = x(:,1:3);
G10 = x(:,4); 
indx = find((G10_date(:,1)==firstdate)&(G10_date(:,2)==01));
G10_date = G10_date(indx:end,:);
G10 = G10(indx:end); 
G10_tim = datenum(G10_date); 


x = load('CPIAUCSL.TXT'); 
cpi_date = x(13:end,1:3);
cpi = (x(13:end,4)./x(1:end-12,4)-1)*100; 
indx = find((cpi_date(:,1)==firstdate)&(cpi_date(:,2)==01));
cpi_date = cpi_date(indx:end,:);
cpi = cpi(indx:end); 
cpi_tim = datenum(cpi_date);

x = load('CPILFENS.txt'); 
core_date = x(13:end,1:3);
core_pi = (x(13:end,4)./x(1:end-12,4)-1)*100; 
indx = find((core_date(:,1)==firstdate)&(core_date(:,2)==01));
core_date = core_date(indx:end,:);
core_pi = core_pi(indx:end); 
core_tim = datenum(core_date);

x = load('GDPDEF.TXT'); 
def_date = x(5:end,1:3);
def = (x(5:end,4)./x(1:end-4,4)-1)*100; 
indx = find((def_date(:,1)==firstdate)&(def_date(:,2)==01));
def_date = def_date(indx:end,:);
def = def(indx:end); 
def_tim = datenum(def_date);


x = load('RESBALNS.txt'); 
res_date = x(:,1:3);
res = x(:,4); 
indx = find((res_date(:,1)==firstdate)&(res_date(:,2)==01));
res_date = res_date(indx:end,:);
res = res(indx:end); 
res_tim = datenum(res_date);

x = load('GDPC96.txt');
dgdp_tim = datenum(x(2:end,1),x(2:end,2),x(2:end,3)); 
dgdp = (x(2:end,4)./x(1:end-1,4)-1)*100;

x = load('unrate.txt');
ur_tim = datenum(x(:,1),x(:,2),x(:,3)); 
ur = x(:,4);

% Load Japanese data
%date all less_rent less_rent_food less_food_energy

x = load('japan_data_2.csv'); 
j_date = x(13:end,1); 
j_yr = floor(j_date/100);
j_mo = j_date-floor(j_date/100)*100;
indx = find((j_yr == j_firstdate)&(j_mo == 1)); 
j_tim = datenum(j_yr(indx:end),j_mo(indx:end),1);
x_adj = x; 
a2014indx = find(x_adj(:,1)==201404); % april 2014
x_adj(a2014indx:end,2:end) = x_adj(a2014indx:end,2:end)+...
    ones(size(x_adj(a2014indx:end,2:end),1),1)*(2*x_adj(a2014indx-1,2:end)-x_adj(a2014indx-2,2:end)-x_adj(a2014indx,2:end)); % adjust for consumption tax 
j_cpi = (x(13:end,2)./x(1:end-12,2)-1)*100; 
j_cpi = j_cpi(indx:end);
j_core = (x(13:end,end)./x(1:end-12,end)-1)*100;
j_core = j_core(indx:end);
j_cpi_adj = (x_adj(13:end,2)./x_adj(1:end-12,2)-1)*100; 
j_cpi_adj = j_cpi_adj(indx:end);
j_core_adj = (x_adj(13:end,end)./x_adj(1:end-12,end)-1)*100;
j_core_adj = j_core_adj(indx:end);


x = load('INTDSRJPM193N.txt'); % discount rate
j_d_date = x(:,1:3); 
j_d = x(:,4); 
indx = find((j_d_date(:,1) == j_firstdate)&(j_d_date(:,2) == 1));
j_d_tim = datenum(j_d_date(indx:end,:)); 
j_d = j_d(indx:end); 

x = load('japan_data/Overnight_Call_Rate_Monthly.csv');
j_cr = x(:,3); % end of month
j_cr_tim = datenum(x(:,1),x(:,2)+1,1); % end of month


x = load('j_10_year.csv'); 
j_10 = x(end:-1:1,:); 
j_10_date = x(:,1:2); 
j_10 = x(:,3); 
indx = find((j_10_date(:,1) == j_firstdate)&(j_10_date(:,2) == 1));
j_10_tim = datenum([j_10_date(indx:end,:) ones(size(j_10_date(indx:end,:),1),1)]); 
j_10 = j_10(indx:end); 


% ***************
% Load Europe Data
% ****************

x = load('europe_inflation.csv'); 
x = x(end:-1:1,:);
eu_tim = datenum(x(:,1),x(:,2),30);
eu_inf = x(:,3); 

x = load('europe_core_inflation.csv'); 
x = x(end:-1:1,:);
eu_core_tim = datenum(x(:,1),x(:,2),30);
eu_core_inf = x(:,3); 

x = load('EUR1MTD156N.csv'); 
x = x(~isnan(x(:,4)),:); % remove rows with NAN rates. 
eu_i_tim = datenum(x(:,1),x(:,2),x(:,3)); 
eu_i = x(:,4); 




% ***********
% plots
% ***********

figure;
plot(ff_tim,ff,'-v','markersize',3,'linewidth',2);
hold on
plot(G10_tim,G10,'-b','linewidth',2);
plot(res_tim,res/1000,'-k','linewidth',2);
plot(core_tim,core_pi,'-r','linewidth',2);
plot(ff_tim,0*ff_tim,'-k');
%legend('Fed Funds','Core CPI','10 Year Treas.','Reserves ($Tr.)'); 
axis([datenum(1996,1,1) datenum(2016,1,1) -inf inf]);

indx = find(ff_tim == datenum(2002,6,1)); 
text(ff_tim(indx),ff(indx)-1,'Fed Funds','color',[0 0.4470 0.7410],'backgroundcolor','w','fontsize',16); 
indx = find(core_tim == datenum(1996,6,1)); 
text(core_tim(indx),core_pi(indx)+0.3,'Core CPI','color','r','backgroundcolor','w','fontsize',16); 
indx = find(G10_tim == datenum(2009,6,1)); 
text(G10_tim(indx),G10(indx)+0.4,'10Y Govt','color','b','backgroundcolor','w','fontsize',16); 
indx = find(res_tim == datenum(2009,6,1)); 
text(res_tim(indx),res(indx)/1000-0.25,'Reserves','color','k','fontsize',16); 
datetick('x','yyyy','keeplimits');
print -depsc2 tb_core_10y_Reserves.eps

figure;
plot(ff_tim,ff,'linewidth',2);
hold on
plot(dgdp_tim,dgdp,'-r','linewidth',2); 
plot(ur_tim,ur,'-k','linewidth',2); 

axis([datenum(1994,1,1),datenum(2017,1,1),-inf inf]);
datetick('x','yyyy','keeplimits');
default_color = get(gca,'colororder');
text(datenum(2008,6,1),3,'Fed Funds','color',default_color(1,:),'fontsize',16);
text(datenum(2008,6,1),8,'Unemployment','color','k','fontsize',16,'horizontalalignment','r');
text(datenum(1996,1,1),-1,'GDP Growth','color','r','fontsize',16);
print -depsc2 unr_gdp.eps; 



figure;
plot(j_d_tim, j_d,'linewidth',2); 
hold on
plot(j_10_tim,j_10,'-b','linewidth',2);
plot(j_cr_tim,j_cr,'-k','linewidth',2);
plot(j_tim, j_core_adj,'-r','linewidth',2);
plot(j_tim, j_core,'--r','linewidth',1)

plot(j_tim,0*j_tim,'-k'); 
datetick('x','yyyy','keeplimits');
indx = find(j_d_tim == datenum(2006,1,1)); 
text(j_d_tim(indx),j_d(indx)+0.2,'Int rate','color','k','horizontalalignment','r',...
    'fontsize',16); 
% was color [0 0.4470 0.7410]
indx = find(j_tim == datenum(2009,1,1)); 
text(j_tim(indx),-1.5,'Core CPI','color','r','fontsize',16,'horizontalalignment','r'); 
indx = find(j_10_tim == datenum(2006,1,1)); 
text(j_10_tim(indx),j_10(indx)+0.7,'10Y Govt','color','b','backgroundcolor','w','fontsize',16); 

%legend('Discount rate','Core CPI','10 year rate'); 
%title('Japan'); 
axis([datenum(1992,1,1) datenum(2016,1,1) -2 6]); 
ylabel('Percent');
datetick('x','yyyy','keeplimits')
print -depsc2 japan_1.eps


figure; 
plot(eu_i_tim,eu_i,'linewidth',2); 
hold on
plot(eu_core_tim,eu_core_inf,'-r','linewidth',2);
%plot(eu_tim,eu_inf,'-k','linewidth',2); 
plot(eu_tim,0*eu_tim,'-k');
default_color = get(gca,'colororder');
text(datenum(2002,1,1),4,'1 mo Euro Libor','color',default_color(1,:),'fontsize', 16);
text(datenum(2004,1,1),1,'Euro Core CPI','color','r','fontsize', 16);
ylabel('Percent');

axis([datenum(1999,1,1) datenum(2017,1,1) -1 5]);
datetick('x','yyyy','keeplimits')
print -depsc2 europe_cpi.eps