% makes velocity graphs
% this is the final one. See money_graphs directory
% for maany variations. 

clear all
close all

x = load('wresbal.csv');
res_date = datenum(x(:,1),x(:,2),x(:,3)); 
res = x(:,4); 

x = load('ff.csv'); 
firstindx = find((x(:,1)==1984) & (x(:,2)==01) & (x(:,3)==04)); 
x = x(firstindx:end,:);
ff_date = datenum(x(:,1),x(:,2),x(:,3)); 
ff = x(:,4);

x = load('frb_prates.csv');
ioer_yr = x(:,1);
ioer_mo = x(:,2);
ioer_dy = x(:,3); 
ioer_date = datenum(ioer_yr,ioer_mo,ioer_dy); 
ioer = x(:,4); 

y = load('gdp.csv');
firstindx = find((y(:,1)==1984)&(y(:,2)==01)); 
y = y(firstindx:end,:); 
gdp_date = datenum(y(:,1),y(:,2),y(:,3)); 
gdp = y(:,4); 

x = load('m1v.csv'); 
m1v_date = datenum(x(:,1),x(:,2),x(:,3));
m1v = x(:,4); 

x = load('m2v.csv'); 
m2v_date = datenum(x(:,1),x(:,2),x(:,3));
m2v = x(:,4); 

x = load('mzmv.csv'); 
mzmv_date = datenum(x(:,1),x(:,2),x(:,3));
mzmv = x(:,4); 

x = load('tb3ms.csv'); 
firstindx = find((x(:,1)==1959)&(x(:,2)==01)); 
x = x(firstindx:end,:);
tb3_date = datenum(x(:,1),x(:,2),x(:,3));
tb3 = x(:,4); 


% *********************
% Reserves vs. fed funds rate
% ********************

% uses weekly data. Needs GDP smoothing i you want to do it. 
if 0;
    for t = 1:size(res,1);
        indx = find(gdp_date==max(gdp_date.*(gdp_date <= res_date(t))));
        resvw(t) = res(t)/gdp(indx);
    end;
    
    figure;
    plot(ff,log(resvw),'-v','linewidth',2)
end;


% this makes it all quarterly. 
 
resq = 0*gdp; 
resq_date = resq;
ffq = 0*gdp; 
ffq_date = ffq; 
ioerq = 0*gdp; 
ioerq_date = ioerq;

for t=1:size(gdp,1); 
    indx = find(abs(res_date-gdp_date(t))==min(abs(res_date-gdp_date(t)))); 
    resq(t) = res(indx); 
    resq_date(t) = res_date(indx); % for checking
    
    indx = find(abs(ff_date-gdp_date(t))==min(abs(ff_date-gdp_date(t)))); 
    ffq(t) = ff(indx); 
    ffq_date(t) = ff_date(indx); % for checking
    
    if gdp_date(t) < datenum(2009,1,1); 
        ioerq(t) = 0; 
        ioerq_date(t) = gdp_date(t);
    else; 
        indx = find(abs(ioer_date-gdp_date(t))==min(abs(ioer_date-gdp_date(t))));
        ioerq(t) = ioer(indx);
        ioerq_date(t) = ioer_date(indx);
    end;
end; 

if 0; % check date assignment
    figure;
    plot(res_date, res);
    hold on
    plot(resq_date, resq,'--r');
    datetick('x')
end


resv = resq./gdp;
indx2007 = find(resq_date == max(resq_date.*(resq_date <= datenum(2007,1,1))));
indx2000 = find(resq_date == max(resq_date.*(resq_date <= datenum(2000,1,1))));

% look at time series to examine 2008 data point
if 0;
    figure;
    plot(resq_date,log(resv),'-v');
    hold on
    plot(ffq_date,ffq,'-rv');
    plot(ioerq_date,ioerq,'-cs');
    legend('reserves','ff','ioer');
    axis([datenum(2008,6,1) datenum(2009,1,1) -inf inf]); 
    datetick('x','yymmdd','keeplimits');
end;

if 0;
    figure;
    plot(res_date,log(res),'-v');
    hold on
    plot(ff_date,ff,'-rv');
    axis([datenum(2008,6,1) datenum(2009,1,1) -inf inf]); 
    datetick('x','yymmdd','keeplimits');   
end;

% Main picture of reserves vs. opportunity cost 

x = ffq(indx2000:indx2007)-ioerq(indx2000:indx2007);
y = log(100*resv(indx2000:indx2007));
x = [ones(size(x,1),1) x];
b = x\y;
xi = [0;10];
fit = [[1;1] xi]*b; 

figure;
plot(ffq(1:indx2000)-ioerq(1:indx2000),log(100*resv(1:indx2000)),'-bv','linewidth',2)
hold on;
plot(ffq(indx2000:indx2007)-ioerq(indx2000:indx2007),log(100*resv(indx2000:indx2007)),'-go','linewidth',2)
plot(ffq(indx2007:end)-ioerq(indx2007:end),log(100*resv(indx2007:end)),'-rs','linewidth',2)
plot(xi,fit,'--k','linewidth',2)
xlabel('Fed Funds Rate - IOER'); 
ylabel('Reserves M/PY (Percent)'); 
text(7,log(0.08),'fit 2000-2007','color','k','fontsize',16);
text(7,log(1.1),'1984-2000','color','b','fontsize',16);
text(0,log(0.06),'2000-2007','color','g','fontsize',16);
text(1,log(3),'2007-2016','color','r','fontsize',16);
axis([-0.25 12 log(0.05) log(20)]); 
h = gca;
h.YTick=log([0.02 0.03 0.05 0.1 0.2 0.3 0.5  1 2 3 5 10 20 30 50]);
h.YTickLabel={'0.02','0.03','0.05','0.1','0.2','0.3','0.5','1','2','3','5','10','20','30','50'};

print -depsc2 reserve_demand.eps

% **********************
% m1 and m2 graphs
% **********************

% make tb3 quarterly. 
 
tb3q = 0*m1v; 
tb3q_date = tb3q;

for t=1:size(m1v,1); 
    indx = find(abs(tb3_date-m1v_date(t))==min(abs(tb3_date-m1v_date(t)))); 
    tb3q(t) = tb3(indx); 
    tb3q_date(t) = tb3_date(indx); % for checking
end; 

startindx = find(m1v_date == datenum(1978,01,01));

indx2007 = find(m1v_date == max(m1v_date.*(m1v_date <= datenum(2007,1,1))));
indx2000 = find(m1v_date == max(m1v_date.*(m1v_date <= datenum(2000,1,1))));

figure; 
plot(tb3q(startindx:indx2000),log(100./m1v(startindx:indx2000)),'-bv','linewidth',2);
hold on;
plot(tb3q(indx2000:indx2007),log(100./m1v(indx2000:indx2007)),'-go','linewidth',2)
plot(tb3q(indx2007:end),log(100./m1v(indx2007:end)),'-rs','linewidth',2)
text(8,log(15),'M1, 1978-2000','color','b','fontsize',16);
text(6.5,log(10.5),'2000-2007','color','g','fontsize',16);
text(0.2,log(13),'2007-2016','color','r','fontsize',16);
xlabel('3 Month Treasury Rate'); 
ylabel('M1 / PY, Percent'); 
h = gca;
h.YTick=log([8 9 10 11 12 13 14 15 16 17 18 19 20 21 22]);
h.YTickLabel={'8', '9', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22'};
print -depsc2 m1_demand.eps;

figure; 
plot(tb3q(startindx:indx2000),log(100./m2v(startindx:indx2000)),'-bv','linewidth',2);
hold on;
plot(tb3q(indx2000:indx2007),log(100./m2v(indx2000:indx2007)),'-go','linewidth',2)
plot(tb3q(indx2007:end),log(100./m2v(indx2007:end)),'-rs','linewidth',2)
text(10,log(57),'M2, 1978-2000','color','b','fontsize',16);
text(6.5,log(47),'2000-2007','color','g','fontsize',16);
text(0.5,log(63),'2007-2016','color','r','fontsize',16);
xlabel('3 Month Treasury Rate'); 
ylabel('M2 / PY, Percent'); 
h = gca;
h.YTick=log([40 45 50 55 60 65 70 75]);
h.YTickLabel={'40', '45', '50', '55', '60', '65', '70', '75'};
print -depsc2 m2_demand.eps;


figure; 
plot(tb3q(startindx:indx2000),log(100./mzmv(startindx:indx2000)),'-bv','linewidth',2);
hold on;
plot(tb3q(indx2000:indx2007),log(100./mzmv(indx2000:indx2007)),'-go','linewidth',2)
plot(tb3q(indx2007:end),log(100./mzmv(indx2007:end)),'-rs','linewidth',2)
text(12,log(32),'MZM, 1978-2000','color','b','fontsize',16);
text(6,log(47),'2000-2007','color','g','fontsize',16);
text(0.5,log(70),'2007-2016','color','r','fontsize',16);
xlabel('3 Month Treasury Rate'); 
ylabel('MZM / PY, Percent'); 
h = gca;
h.YTick=log([20 25 30 35 40 45 50 60 70 80]);
h.YTickLabel={'20', '25', '30', '35', '40', '45', '50', '60', '70','80'};
%print -depsc2 mzm_demand.eps;

