% does very simple IR function for mba talk / modified for mm paper. 
% this is the final version. the version in talks subdirectory has extras

clear all
close all
 
sig = 1; 

% NK constant rate 
kv = [1/2 1]; 
tim = (-3:20)';
it = [zeros(3,1);ones(21,1)];
 
pit = 0*it*(1+0*kv); 
for t = 1:(size(it,1)-1);
    pit(t+1,:) = 1./(1+1./(sig.*kv))*it(t) + (1./(sig.*kv))./(1+1./(sig.*kv)).*pit(t,:);
end;

deltat = ((1./(sig.*kv(1)))./(1+1./(sig.*kv(1)))).^tim; 

figure
default_color = get(gca,'colororder'); 
plot(tim-0.02,it+0.02,'--sm','linewidth',2);
hold on
plot(tim,pit(:,1)*ones(1,5)+deltat*[-.3  .3 1 .8 1.2],'--sm','linewidth',1.5);
plot(tim,[it pit(:,2) pit(:,1)],'-v','linewidth',2);

xlabel('time')
ylabel('percent');
text(-0.3,1,'Interest i','fontsize',20,'color',default_color(1,:),'horizontalalignment','r','backgroundcolor','w');
text(tim(6)+.2,pit(6,1),'Inflation \pi','fontsize',20,'color',default_color(3,:),'backgroundcolor','w');
text(1,1.1,'Standard NK','color','m','fontsize',20,'backgroundcolor','w');
axis([-2 5 -0.4 1.2]);

text(1.5,.2,'With fiscal shocks','fontsize',20,'color','m','backgroundcolor','w');
text(tim(6)-.2,pit(6,2),'Less sticky','fontsize',20,'color',default_color(2,:),'horizontalalignment','r','backgroundcolor','w')

print -depsc2 simple_ir_NK.eps

% NK response to vi shocks. 


tim = (-5:20)';
vi0 = -1/2; 
T1 = 6; 
kap = kv(1); 
phi = 1.5;
vit = vi0*[zeros(T1-1,1);ones(size(tim,1)-T1+1,1)];
it = 0*vit;
pibar = -1/(phi-1)*vi0; 
ibar = pibar; 

pit = 0*it;
pit_ant = pit; 
it_ant = it; 
for t = 1:(size(it,1)-1);
    if t<T1; 
        pit_ant(t) = ((1+sig*kap)/(1+phi*sig*kap))^(T1-t)*pibar;
        it_ant(t) = phi*pit_ant(t);
        pit(t) = 0; 
        it(t) = 0; 
    else; 
        pit_ant(t) = pibar;
        it_ant(t) = pibar; 
        pit(t) = pibar;
        it(t) = pibar; 
    end;
end;



% now with transitory 
rhov = [ 1 0.9 1/(1+sig*kap) 0.3];
N = size(rhov,2);
Tt = size(tim,1)-T1+1;
vit = vi0*[zeros(T1-1,N);(ones(Tt,1)*rhov).^((0:size(tim,1)-T1)'*ones(1,N))];
pit = -(ones(size(vit,1),1)*(sig*kap ./ (1-rhov + (phi-rhov)*sig*kap))).*vit; 
it = (ones(size(vit,1),1)*((1-rhov*(1+sig*kap))./(1-rhov+(phi-rhov)*sig*kap))).*vit;

figure
for indx = 1:N;
subplot(2,2,indx)
default_color = get(gca,'colororder');
plot(tim,0*tim,'-k')
hold on
plot(tim,[it(:,indx)./pit(T1,indx) ],'-v','linewidth',2);
plot(tim,[pit(:,indx)./pit(T1,indx)],'-r','linewidth',2);
plot(tim,vit(:,indx)./pit(T1,indx),'--m','linewidth',2);

xlabel('time')
ylabel('percent');
if ~(indx == 3);
    title(['\rho = ' num2str(rhov(indx))], 'fontsize',20);
else
    title(['\rho = 2/3'], 'fontsize',18);
end
if indx == 2; 
    text(0,-0.5,'v^i','color','m','fontsize',18)
    text(-0.9,0.9,'\pi','color','r','fontsize',18)
    text(2,0.3,'i','color','b','fontsize',18);
end
    
    %text(-0.5,1,'Interest i','fontsize',20,'color',default_color(1,:),'horizontalalignment','r');
%text(tim(6)+.2,pit(6,1),'Inflation \pi','fontsize',20,'color',default_color(2,:),'backgroundcolor','w');
axis([-2 5 -1.2 1.2]);
end;

% print -depsc2 simple_ir_NK_phi.eps
% deleted in favor of same with real model. 


% OK phi = 0 i step function 
tim = (-3:20)';
it = [zeros(3,1);ones(21,1)];
pit_ok = 0*it*(1+0*kv);

for t = 1:(size(it,1)-1);
    pit_ok(t+1,:) = -1./(1./(sig.*kv)).*it(t) + (1+1./(sig.*kv))./(1./(sig.*kv)).*pit_ok(t,:);
end;

figure
plot(tim,[it+0.05 pit_ok(:,2)-0.05 pit_ok(:,1)-0.05],'-v','linewidth',2);
hold on
axis([-3 5 -10 2]);
default_color = get(gca,'colororder'); 
xlabel('time')
ylabel('percent');
text(-0.5,1,'Interest i','fontsize',20,'color',default_color(1,:),'horizontalalignment','r');
text(tim(6)+0.2,pit_ok(6,1),'Inflation \pi','fontsize',20,'color',default_color(3,:))
text(tim(6)-0.2,pit_ok(6,2),'\pi, less sticky','fontsize',20,'color',default_color(2,:),'horizontalalignment','r')


print -depsc2 simple_ir_eps.eps


% OK phi = 0 vr step function
% this generalizes the taylor rule to i = max[ ibar + phi(pi-pibar),0]
rbar = 2;% = r*  
pibar = 1.5; 
vrt = -3*[zeros(3,1);ones(21,1)];
vrt = -3*[zeros(3,1);ones(8,1); zeros(13,1)];
phi = 1.5; 
k = kv(1);
it_ok = 0*vrt;
pit_ok = 0*vrt;
it_ok(1) = rbar+pibar;
pit_ok(1) = pibar; 
for t = 1:(size(it,1)-1);
    if rbar+pibar+phi*(pit_ok(t)-pibar)>0;
        pit_ok(t+1,:) = pibar + sig*k./(1+sig*k*phi).*vrt(t) +...
        (1+sig*k)/(1+ sig*k*phi).*(pit_ok(t,:)-pibar);
        it_ok(t) = rbar + pibar + phi*(pit_ok(t)-pibar);
    else;
        pit_ok(t+1,:) = (1+sig*k)*pit_ok(t,:)+(sig*k)*(rbar+vrt(t));
        it_ok(t) = 0;
    end;
end;
figure;
plot(tim,vrt,'--vm','linewidth',2);
hold on
plot(tim,pit_ok,'-vr','linewidth',2);
plot(tim,it_ok,'-vb','linewidth',2); 
plot(tim,0*tim,'-k')
axis([-3,10,-12,5]);
text(2,vrt(2+4),'v^r','color','m','fontsize',22,'backgroundcolor','w');
text(-2,it_ok(-2+4),'i','color','b','fontsize',22,'backgroundcolor','w');
text(-1,pit_ok(-1+4),'\pi','color','r','fontsize',22,'backgroundcolor','w');
%legend('vr','\pi','i');
xlabel('Time', 'fontsize', 20)

ylabel('Percent', 'fontsize',20)
print -depsc2 old_k_spiral.eps
%print -dpng old_k_spiral.png

% OK with step v, phi > 1  
vit = [zeros(3,1);ones(21,1)];
phi = 1.5; 
k = kv(1);
it_ok = 0*vit;
pit_ok = 0*vit; 
for t = 1:(size(it,1)-1);
    pit_ok(t+1,:) = -sig*k./(1+sig*k*phi).*vit(t) + (1+sig*k)/(1+ sig*k*phi).*pit_ok(t,:);
end;
it_ok = vit + phi*pit_ok; 

figure;
plot(tim,vit+0.025,'-vm','linewidth',2);
hold on
plot(tim,pit_ok-0.025,'-rv','linewidth',2);
plot(tim,it_ok,'-bv','linewidth',2); 
axis([-3,15,-2 1.2]);
text(2,vit(2+4),'v^i','color','m','fontsize',20,'backgroundcolor','w');
text(2,it_ok(2+4),'interest i','color','b','fontsize',20,'backgroundcolor','w');
text(3,pit_ok(3+4),'inflation \pi','color','r','fontsize',20,'backgroundcolor','w','horizontalalignment','r');
%legend('vi','\pi','i');
xlabel('Time')
ylabel('Percent')
print -depsc2 old_k_ir_withphi.eps


% NK with end of trap

k = kv(1); 
sig = 1; 
phi = 2; 
pistar = 2; 
T = 5; 
T2 = 10; 
tim = (1:T2)';
pi1 = (-3:2)+pistar;
pit = 0*tim*pi1;
pit(T,:)=pi1;
for j = 1:size(pi1,2); 
    for t = T:-1:2;
        pit(t-1,j) = (1+sig*k)*pit(t,j); % work back
    end;
    for t=T+1:T2;
        pit(t,j) = pistar + (1+sig*k*phi)/(1+sig*k)*(pit(t-1,j)-pistar);
    end;
end;


% a different approach aiming to low inflation then more

taylormax = 1; % is it peg or not, or is it max(taylor, 0); 
k = kv(1); 
sig = 1; 
phi = 2; 
pistar = 2; 
vrpre = -2; 
vrpost=0; % vr shocks 
T = 10; 
T2 = 15; 
tim = (1:T2)';
pi1 = ([-3 -2 -1 -0.5 0 0.5 1 2])+pistar;
indx0 = find(pi1==pistar); 
pit = 0*tim*pi1;
it = 0*pit; 
pit(T,:)=pi1;
if ~taylormax;
    it(T,:) = phi*pit(T,:) + (1-phi)*pistar;
end;
if taylormax;
    it(T,:) = max( [(phi*pit(T,:) + (1-phi)*pistar);0*pit(T,:)] );
end;
for j = 1:size(pi1,2); 
    for t = T:-1:2;
        if ~taylormax;
            pit(t-1,j) = (1+sig*k)*pit(t,j)+sig*k*vrpre; % work back
            it(t-1,j) = 0;
        end;
        if taylormax;
            pit(t-1,j) = (1+sig*k)/(1+phi*sig*k)*(pit(t,j)-pistar) + ...
                pistar + sig*k/(1+phi*sig*k)*vrpre; %guess taylor
            it(t-1,j) = phi*pit(t-1,j) + (1-phi)*pistar; 
            if it(t-1,j) < 0; %whoops, zero boud
                pit(t-1,j) = (1+sig*k)*pit(t,j)+sig*k*vrpre; % work back
                it(t-1,j) = 0;
            end;
        end;
            
    end;
    for t=T+1:T2;
        if ~taylormax
            pit(t,j) = pistar + (1+sig*k*phi)/(1+sig*k)*(pit(t-1,j)-pistar)...
            -sig*k/(1+sig*k)*vrpost;
            it(t,j) = phi*pit(t,j) + (1-phi)*pistar;
        end;
        if taylormax
            if it(t-1,j) > 0;
                pit(t,j) = pistar + (1+sig*k*phi)/(1+sig*k)*(pit(t-1,j)-pistar)...
                -sig*k/(1+sig*k)*vrpost;
                it(t,j) = max(phi*pit(t,j) + (1-phi)*pistar,0);
            end;
            if it(t-1,j) <= 0; % both phi and vi become 0
                pit(t,j) = 1/(1+sig*k)*pit(t-1,j)...
                -sig*k/(1+sig*k)*vrpost;
                it(t,j) = max(phi*pit(t,j) + (1-phi)*pistar,0);
            end
        end;
    end;
end;

figure;
plot(tim,pit,'--','linewidth',2);
hold on
plot(tim,0*tim,'-k')
plot(tim,pit(:,indx0),'-k','linewidth',2)
plot([T T], [-10 10], '--k');
text(T-3,8,['v^r = ' num2str(vrpre)],'fontsize',16) 
text(T+1,8,'v^r = 0','fontsize',16,'backgroundcolor','w') 
axis([0 T2 -10 10]);
xlabel('time');
title('Inflation');
ylabel('percent');
print -depsc2 escape2.eps


figure;
hold on
plot(tim,0*tim,'-k')
plot(tim,it,'--','linewidth',2)
plot(tim,it(:,indx0),'-k','linewidth',2)
%plot([0 0], [-10 10], '--k');
plot([T T], [-10 10], '--k');
text(T-3,8,['v^r = ' num2str(vrpre)],'fontsize',16) 
text(T+2,8,'v^r = 0','fontsize',16,'backgroundcolor','w') 
axis([0 T2 -1 10]);
title('Interest rate')
xlabel('time');
ylabel('percent');
print -depsc2 escape2i.eps



