% very simple model with static phillips curve
% modified since blog/summers letter to use the paper color scheme
% this is the final version, see root directory for earlier ones

clear all
close all

sig =1;
k = 1; 
gam = 1; % 0 for static phillips, 1 for pi - (1-lambada) sum lambda j pi t-j 
lam = 0.9; 

colors = get(groot,'defaultaxescolororder');
    
T = 100;
tim = (-10:T');
it = [zeros(10,1);ones(T+1,1)];
pit = 0*it; 
ct = 0*it;
piet = 0*it; 
for t = 3:size(it,1) ;
    pit(t) = 1/(1+sig*k)*(pit(t-1)+(piet(t-1)-piet(t-2))) + sig*k/(1+sig*k)*it(t-1);
    piet(t) = lam*piet(t-1) + gam*(1-lam)*pit(t); 
    ct(t) = k*(pit(t) - piet(t-1));    
end;

% gamma 0 deleted see root. 

if gam == 1;
    figure;
    plot(tim,it,'-gv','linewidth',2);
    hold on
    plot(tim,pit,'-rs','linewidth',2);
    
    %legend('i','\pi','c','location','southeast')
    plot(tim,0*tim,'-k');
    xlabel('time');

    
    plot(tim,ct,'--k','linewidth',2);
    colors = get(groot,'defaultaxescolororder')
    text(-2.5,1.05,'interest rate i','fontsize',16,'color','g');
    text(3.5,0.9,'inflation \pi','fontsize',16,'color','r');
    text(8,0.2,'output gap x','fontsize',16,'color','k');
   
    axis([-3 15 -0.2 1.2])
    %print -dpng summers2png.png
    print -depsc2 summers2.eps
end
    